#version 330 core

//----------------------------------------------
// GEOMETRY SHADER
// C EST LE TROISIEME PROGRAMME EXECUTE PAR LA CARTE GRAPHIQUE
//----------------------------------------------

// IL "AVALE" EN ENTREE LES TRIANGLES DONT LA TOPOLOGIE A ETE CALCULEE PAR LE TESSELLATION CONTROL SHADER 
// ET DONT LA GEOMETRIE A ETE CALCULE PAR LE TESSELLATION EVALUATION SHADER
layout(triangles) in;

// EN SORTIE ON IMPLEMENTE DEUX POSSIBILITES: SOIT ON NE SORT QUE LES BORDS DES TRIANGLES
// SOIT ON REMPLIE LES TRIANGLES
// POUR DESSINER JUSTE LES ARETES
//layout(line_strip, max_vertices = 4) out;

// POUR REMPLIR LES FACES
layout(triangle_strip, max_vertices = 3) out;

uniform mat4 MaMatriceDeProjection;

in float Ecart[];
in float TessX[], TessY[];

out float EcartPourInterpolation;
out float TessXInt, TessYInt;

void main(void)
{
// ON DOIT AVOIR gl_in.length() = 3 CAR LE TESSELLATEUR CALCULE DES TRIANGLES 
	for(int i = 0; i < gl_in.length(); ++i)
	{
		gl_Position = transpose(MaMatriceDeProjection) * gl_in[i].gl_Position;
		EcartPourInterpolation = Ecart[i];
		TessXInt = TessX[i];
		TessYInt = TessY[i];

// ON RAJOUTE UN i-eme SOMMET A LA PRIMITIVE
		EmitVertex();
	}

// AU CAS OU ON VEUT DESSINER LES CONTOURS DU TRIANGLE, IL FAUT RESSORTIR LE POINT D'ORIGINE POUR BOUCLER LE CONTOUR
// SI ON GENERE QUAND MEME UN 4IEME POINT POUR REMPLIR LE TRIANGLE, CELA NE POSE PAS DE PROBLEME AU RASTERIZER QUI
// IGNORERA LE 4IEME POINT.
	gl_Position = transpose(MaMatriceDeProjection) * gl_in[0].gl_Position;
	EcartPourInterpolation = Ecart[0];
	TessXInt = TessX[0];
	TessYInt = TessY[0];

// ON RAJOUTE UN SOMMET A LA PRIMITIVE
	EmitVertex();
	
// ON TERMINE LA PRIMITIVE (SOIT line_strip SOIT triangle_strip SUIVANT LE layout CHOISI AU DEBUT DU PROGRAMME
	EndPrimitive();
}
